<?php
/*	user-check (>=10)
*/
	if ( checkstat($_SESSION['user'], $_SESSION['status'], $levels[$page], $lang_err, $acttime - $_SESSION['delay']) ) {

/*	POST-Variablen Uebernahme
*/

	$name = clearify($_FILES['userfile']['name']);
	$typ = unesc($_POST["typ"]);
	$uploader = unesc($_POST["uploader"]);
	$beschreibung = clearify(unesc($_POST["beschreibung"]));
	$bewertung = unesc($_POST["bewertung"]);
	$purename = clearify(unesc($_POST["purename"]));
	$imdblink = unesc($_POST["imdblink"]);
	$anmelden = unesc($_POST["register"]);
	$torrenturl = unesc($_POST["torrenturl"]);
	
	$max_torrent_size = $_POST["MAX_FILE_SIZE"];
			
/*	upload-daten entgegennehmen
	und b-decoden. ($dict = bdeced dictionary)
*/
	$okay = false;

	if ( $torrenturl ) {
		$torrenturl = str_replace(" ", "%20", $torrenturl);
		if ( $f = @fopen($torrenturl, 'rb') ) {
			$okay = true;
			$torrent = '';
			while ( !feof($f) ) {
				$torrent .= fgets( $f, 4096 );
			}
			$dict = bdec($torrent);
			preg_match( "/http\:\/\/.*\/(.*?\.torrent)/", $torrenturl, $dname );
			$dname[1] = urldecode($dname[1]);
			$torrentname = str_replace(" ", "_", $dname[1]);
			if ($f = @fopen($uldir . $torrentname, 'wb')) {
				fwrite ($f, $torrent, strlen($torrent));
				fclose($f);
			} else {
				$okay = false;
			}
			$name = $torrentname;
		} else {
			$okay = false;
		}
	} else {
		$tmpname = $_FILES['userfile']['tmp_name'];
		$dict = bdec_file($tmpname, $max_torrent_size);

/*	file verschieben (und checken, ob OK)
*/	
		if ( move_uploaded_file($_FILES['userfile']['tmp_name'], $uldir . $_FILES['userfile']['name']) ) $okay = true;
	}
	
	if ( $okay ) {
/*	Wenn Endung nicht .torrent, dann umbenennen
*/

//		if ( strrchr($_FILES['userfile']['name'], ".") != ".torrent" ) {
//			$name = str_replace( strrchr($name, "."), ".torrent", $name);
//			chmod ($uldir . $_FILES['userfile']['name'], 777);
//			rename($uldir . $_FILES['userfile']['name'], $uldir . $name);
//		}
/*	check, ob es sich ueberhaupt um ein
	benced file handelt..
*/
		if ( !isset($dict) ) {
			bark($lang_torrentsonly);
		} else {

/*	Check, ob Beschreibung eingegeben wurde..
*/

			if ( strlen($beschreibung) < 5 ) bark($lang_shortdesc ." <a href='index.php?page=upload'>$lang_back...</a>");

/*	Infos aus dem Torrent
*/
			list($ann, $info) = dict_check($dict, "announce(string):info");
			$error = 0;
			if ( $inttracker == false ) {
				if ( $ann == $annurl ) $error = 1;
			}
			if ( $exttracker == false ) {
				if ( $ann != $annurl ) $error = 2;
			}
			if ( $error == 1 ) {
				unlink($uldir . $_FILES['userfile']['name']);
?>
				<h3><?php echo htmlentities($lang_nointtracker); ?></h3>
<?php
			} elseif ( $error == 2 ) {
				unlink($uldir . $_FILES['userfile']['name']);
?>
				<h3><?php echo htmlentities($lang_noexttracker . $annurl); ?></h3>
<?php
			} else {
				list($dnme, $plen, $pieces) = dict_check($info, "name(string):piece length(integer):pieces(string)");
				$dname = clearify($dnme);

/*	Dateigroese und Check ob single-
	oder multifile.
	
	FREMDCODE - ZU ERSETZEN!
*/
				$filelist = array();
				$totallen = dict_get($info, "length", "integer");
				if ( isset($totallen) ) {
					$filelist[] = array($dname, $totallen);
					$anzfiles = 1;
					$type = "single";
				} else {
					$flist = dict_get($info, "files", "list");
					if ( !isset($flist) ) {
						bark("missing both length and files");
					}
					if ( !count($flist) ) {
						bark("no files");
					}
					$totallen = 0;
					$anzfiles = count($flist);
					foreach ( $flist as $fn ) {
						list($ll, $ff) = dict_check($fn, "length(integer):path(list)");
						$totallen += $ll;
						$ffa = array();
						foreach ( $ff as $ffe ) {
							if ($ffe["type"] != "string") {
								bark("filename error");
							}
							$ffa[] = $ffe["value"];
						}
						if ( !count($ffa) ) {
							bark("filename error");
						}
						$ffe = implode("/", $ffa);
						$filelist[] = array($ffe, $ll);
					}
					$type = "multi";
				}

/*	infohash und scrapeurl
*/
				$infohash = pack("H*", sha1($info["string"]));
				$scrape = str_replace("announce", "scrape", $ann);
				
/*	hash sql-tauglich formatieren
*/
				$eschash = enchash($infohash);
				
/*	dupe-check
*/
				$dupecheck = query($dbh, "SELECT null FROM torrents WHERE hash='$eschash'", false);
				if ( num_rows($dupecheck) > 0 ) $dupe = true; else $dupe = false;

/*	Tracker-Status
*/
				if ( $ann != $annurl ) {
					$tr_info = check_tracker($scrape, $eschash);
					$dld = $tr_info["d"];
					$incomp = $tr_info["i"];
					$comp = $tr_info["c"];
					$id = '';
					$anzwert = 1;
				} else {
					$dld = "purged";
					$incomp = "purged";
					$comp = "purged";
					$id = '';
					$anzwert = 1;
				}



/*	Wenn kein Name eingegeben wurde, aus
	dem filename uebernehmen
*/
				if ( $purename == "" ) $purename = $name;

/*	$purename bereinigen
*/

				$purename = str_replace(".torrent", "", $purename);
				$purename = str_replace("_", ".", $purename);
				$purename = str_replace(".", " ", $purename);
				$purename = chop($purename);
				$purename = str_replace(" ", ".", $purename);
				$purename = preg_replace("/\.+/", ".", $purename);

			
/*	Wenn kein Link angegeben wurde,
	es sich aber um einen Film, oder eine Serie handelt,
	Link selbst erstellen.
*/

				$search = preg_replace("/(\.avi|mpg|mpeg|\.ace|\.zip|\.rar|\.exe|\.iso|season|episode|mvcd|svcd|xvcd|vcd|dvd-r|dvd|xvid|divx|div-x|ac3|disc|cd|ts|ftl|tc|cam|telesync|telecine|german|englisch|deutsch|english|devine|screener|proper|limited|internal|repack|\.de|\.com|\.dl|\.am|www\.|bitleeching|\(|\)|0|1|2|3|4|5|6|7|8|9)/i", "", $purename);
				$search = str_replace("-", ".", $search);
				$search = preg_replace("/\s+/", " ", $search);
				$search = preg_replace("/\.+/", ".", $search);
				$search = str_replace(".", " ", $search);
				$search = chop($search);

				switch ($typ) {
					case "2":
						if ( $imdblink == "" ) {
							$imdblink = "http://epguides.master.com/texis/master/search/?q=". urlencode($search) ."&xsubmit=Search&s=SS";
						}
						break;
					case "3":
						if ( $imdblink == "" ) {
							$imdblink = "http://www.imdb.com/find?q=". urlencode($search);
						}
						break;
					default:
						$imdblink = "-";
						break;
				}
		
/*	registrier-pflichtiger tracker
*/

				if ( $anmelden == "true" ) $register = 1; else $register = 0;

/* genre-name aus db auslesen
*/
				$genres = query($dbh, "SELECT name FROM genres WHERE id = '$typ'");
				$grow = fetch_object($genres);
				$genre = $grow->name;

/*	torrent in die db aufnehmen
*/
				if ( !$dupe ) {
				
				addtorrent($dbh, $typ, $name, $bewertung, $aktdatetime, $totallen, $uploader, $dname, $beschreibung, $ann, $eschash, $dld, $incomp, $comp, $purename, $imdblink, $anzfiles, $register, $acttime - $updatetime*7200, $_SESSION['UID']);

					if ( $log["upload"] == "1" ) {
						$ipaddr = $_SERVER['REMOTE_ADDR'];
						$ids = query($dbh, "SELECT id FROM torrents WHERE hash = '$eschash'");
						$idrow = fetch_object($ids);
						$id = $idrow->id;
						$detailsurl = $yabtucurl ."index.php?page=details&amp;id=$id";
						$lf = fopen ($logfile, 'a');
						fwrite($lf, $ipaddr .' - '. $user .' ['. $logdate .'] "UPLOAD '. $name .' - '. $detailsurl .'"' . "\r\n");
						fclose($lf);
					}

/*	upload-counter +1
*/
					$ergebnis = query($dbh, "SELECT * FROM users WHERE name='$user'");
					$row = fetch_object($ergebnis);
					$userup = $row->upd;
					$userup++;
					query($dbh, "UPDATE users SET upd='$userup' WHERE name='$user'");

/*	ID aus db auslesen
*/
					$ids = query($dbh, "SELECT id FROM torrents WHERE hash = '$eschash'");
					$idrow = fetch_object($ids);
					$id = $idrow->id;

/*	RSS-Feed erstellen
*/

/*	Altes RSS-File auslesen
*/
					$feed = rssdecode($rssfile);
/*	Neuen Item-Eintrag erstellen
*/

					$rname = str_replace(" ", "%20", $name);
		
					$newitems = "\r\n\t\t\t<item>".
								"\r\n\t\t\t\t" . createtags("title", $genre .": ". htmlentities($purename)).
								"\r\n\t\t\t\t" . createtags("link", $yabtucurl ."data/php/download.inc.php?id=". $id).
								"\r\n\t\t\t\t" . createtags("description", htmlentities("Tracker: ". $ann ."<br />". $beschreibung)).
								"\r\n\t\t\t\t" . createtags("guid isPermaLink='false'", dechash($infohash)).
								"\r\n\t\t\t\t" . createtags("pubdate", $rsstime).
								"\r\n\t\t\t</item>";


/*	Alte Item-Eintraege anhaengen
*/
					for ( $ic = 0; $ic <= 10; $ic++ ) {
						$newitems = $newitems . "\r\n\t\t\t<item>".
									"\r\n\t\t\t\t" . createtags("title", $feed["items"][$ic]["title"]).
									"\r\n\t\t\t\t" . createtags("link", $feed["items"][$ic]["link"]).							
									"\r\n\t\t\t\t" . createtags("description", $feed["items"][$ic]["description"]).
									"\r\n\t\t\t\t" . createtags("guid isPermaLink='false'", $feed["items"][$ic]["guid"]).
									"\r\n\t\t\t\t" . createtags("pubdate", $feed["items"][$ic]["pubdate"]).
									"\r\n\t\t\t</item>";
					}

/*	Neues RSS-File zusammenstellen
*/
					$newfile =	$feed["xmlhead"] . "\r\n\t".
								$feed["rsshead"] . "\r\n\t\t".
								"<channel>" . "\r\n\t\t\t".
								createtags("title", $feed["head"]["title"]) . "\r\n\t\t\t".
								createtags("link", $feed["head"]["link"]) . "\r\n\t\t\t".
								createtags("description", $feed["head"]["description"]) . "\r\n".
								$newitems . "\r\n\t\t\t".
								"</channel>" . "\r\n\t".
								"</rss>" . "\r\n";
		
					$nr_of_bytes = 0;
					if ( ($file = fopen($rssfile, "wb+")) === false ) {
						echo "could not open file";
						die();
					}
					
					if ( ($nr_of_bytes = fwrite($file, $newfile)) === false) {
						echo "could not write to file";
						die();
					}
					fclose($file);
			}

/*	html-Ausgabe...
*/
		if ( !$dupe ) {
?>
			<h3 align="center">
<?php
				echo htmlentities($lang_uploaded);
?>
			</h3> 
			<table width="700" border="0" align="center" cellpadding="0" cellspacing="0"> 
				<tr>
					<td background="data/pix/bg/em_ul.jpg" height="15" width="60">&nbsp;
			
					</td>
					<td background="data/pix/bg/em_um.jpg" width="570">&nbsp;
						
					</td>
					<td background="data/pix/bg/em_ur.jpg" width="70">&nbsp;
						
					</td>
				</tr>
				<tr>
					<td colspan="3" class="back2" align="center">
						<br />
	
						<table width="600"  border="0" align="center" cellpadding="2" cellspacing="2"> 
							<tr> 
								<td width="111" align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_name) .":";
?>
								</td> 
								<td width="481" align="left" class="defaulttabletext">
<?php
									echo substr($purename,0,64);
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_torrentname) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo substr($name,0,64);
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_filedir) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo substr($dname,0,64);
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_size) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo convsize($totallen);
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_typ) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo "$genre";
?>
								</td> 
							</tr> 
<?php
/*	Wenn Typ <= 2, imdb-link
*/
							if ( $typ <= 2 ) {
?>
								<tr>
									<td align="left" valign="top" class="defaulttablehead">
<?php
										echo htmlentities($lang_imdblink) .":";
?>
									</td>
									<td align="left" class="defaulttabletext">
<?php
										echo substr(clearify($imdblink), 0, 64);
										if ( strlen(clearify($imdblink)) > 64 ) echo "[...]";
?>
									</td>
								</tr>
<?php
							}
?>
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_tracker) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo "$ann";
?>
								</td> 
							</tr>
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_snatched) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo "$dld";
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_seeder) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo "$comp";
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_leecher) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo "$incomp";
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_hash) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo dechash($infohash);
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_judgement) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo "$bewertung";
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_desc) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo str_replace("\\r\\n", "<br />", bbdecode($beschreibung));
?>
								</td> 
							</tr> 
							<tr> 
								<td align="left" valign="top" class="defaulttablehead">
<?php
									echo htmlentities($lang_uploader) .":";
?>
								</td> 
								<td align="left" class="defaulttabletext">
<?php
									echo "$uploader";
?>
								</td> 
							</tr> 
							<tr> 
								<td>&nbsp;
									
								</td> 
								<td align="right">
									<a href="index.php?page=upload"><?php echo htmlentities($lang_back); ?>...</a>
								</td> 
							</tr> 
						</table> 
					<br />
					</td>
				</tr>
				<tr>
					<td background="data/pix/bg/em_ll.jpg" height="21" width="60">&nbsp;
						
					</td>
					<td background="data/pix/bg/em_lm.jpg">&nbsp;
						
					</td>
					<td background="data/pix/bg/em_lr.jpg" width="70">&nbsp;
						
					</td>
				</tr>
			</table>
<?php
		} else {
?>
			<h3>
<?php
				echo htmlentities($lang_nodupes);
?>
			</h3>
<?php
		}
?>
		<br />
<?php
		}
	}
		} else {
		   print "Possible file upload attack!  Here's some debugging info:\n";
		   print_r($_FILES);
		   die();
		}
}
?>